#include "MFC_Library1.h"
#include "UtilityFunctions.h"

// DEBUG_NEW macro allows MFC applications to determine memory leak locations in debug builds
#ifdef _DEBUG
  #define new DEBUG_NEW
#endif

bool ReplaceDialogControl(CDialog& dlg, UINT control_id, CDialog& new_control_group, UINT control_group_id)
{
  // a. use control_id to figure out on-screen area for replacement window
  CWnd* pPlaceHolder = dlg.GetDlgItem(control_id);
  if(NULL == pPlaceHolder)
    return false;

  CRect rect;
  pPlaceHolder->GetWindowRect(rect);
  dlg.ScreenToClient(rect);

  // b. destroy the place holder, 
  pPlaceHolder->DestroyWindow();
  
  // convert the static's screen rectangle to the dialog's client coordinates
  if ( !new_control_group.Create(control_group_id, &dlg) )
  {
    dlg.MessageBox(L"Creation of control Dialog Failed!!");
    return false;
  }

  new_control_group.MoveWindow(rect, FALSE);
  new_control_group.BringWindowToTop();
  new_control_group.ShowWindow(SW_SHOWDEFAULT);
  new_control_group.UpdateWindow();
  return true;
}
