// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////

/// Utility functions for working with MFC controls
#pragma once

/// Replace a control defined with the resource editor with a "sub"-dialog. This provides for
/// generating re-usable control panels
/// \param dlg The parent dialog that contains the placeholder control
/// \param control_id The ID of the placeholder control on dlg
/// \new_control_group Reference to the MFC dialog class that defines the child dialog with controls
/// \control_group_id Typically the IDD of the new_control_group dialog class
/// \return true on success
bool ReplaceDialogControl(CDialog& dlg, UINT control_id, CDialog& new_control_group, UINT control_group_id);
