// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "CircleRadiusControls.h"

/// Main dialog for the sample application. This is created and displayed in
/// the CTutorialApp::InitInstance function.
class CTutorialDlg : public CDialog
{
public:
  CTutorialDlg(CWnd* pParent = NULL);

  /// The IDD enum is a common technique in MFC to associate a dialog with
  /// a resource that you edit in the dialog editor
  enum { IDD = IDD_GROUPCONTROLS_DIALOG };

protected:
  /// Called immediately after a dialog is created, but before it is displayed.
  /// This is where all of the control initialization usually occurs. This is
  /// also where the graphics window is set up
  virtual BOOL OnInitDialog();

  /// A message map is an MFC macro for mapping window's events (paint, size, mouse,...) that
  /// occur on a window to functions in this class.
  /// The functions in this class that begin with afx_msg are "handlers" for window's messages
  DECLARE_MESSAGE_MAP()

  /// Called when this dialog receives a WM_PAINT message (event)
  /// The MFC wizard adds code to paint properly if this dialog is minimized to the taskbar
  afx_msg void OnPaint();

private:
  /// A child dialog with controls for adjusting circle radius
  CCircleRadiusControls m_circle_controls;

  HICON m_hIcon;
};
